---
apiVersion: infrastructure.cluster.x-k8s.io/v1beta1
kind: OpenStackMachineTemplate
metadata:
  name: {{ capi_cluster }}-{{ group.name }} # SPEC HASH SUFFIX ADDED DURING RENDERING
  namespace: {{ capi_kube_namespace }}
  labels:
    capi.skao.int/cluster: {{ capi_cluster }}
    capi.skao.int/component: worker
    capi.skao.int/worker-group: {{ group.name }}
spec:
  template:
    spec:
      flavor: {{ group.flavour | default(capi_capo_node_machine_flavour) }}
      identityRef:
        name: {{ capi_cluster }}-cloud-config
        cloudName: {{ capi_capo_openstack_cloud }}
      image:
        filter:
          name: {{ group.image | default(capi_capo_openstack_image_name) }}
      ports:
        # set to true if using MetalLB: https://metallb.universe.tf/installation/clouds/#metallb-on-openstack
      - disablePortSecurity: {{ capi_capo_openstack_disable_port_security | lower }}
        network:
          filter:
            name: {{ capi_capo_openstack_network_name }}
{% if not capi_capo_openstack_disable_port_security %}
      securityGroups: {{ capi_capo_openstack_security_groups | default([]) | to_json }}
{% endif %}
      sshKeyName: {{ group.ssh_key | default(capi_capo_openstack_ssh_key_name) }}
---
apiVersion: bootstrap.cluster.x-k8s.io/v1beta1
kind: KubeadmConfigTemplate
metadata:
  name: {{ capi_cluster }}-{{ group.name }} # SPEC HASH SUFFIX ADDED DURING RENDERING
  namespace: {{ capi_kube_namespace }}
  labels:
    capi.skao.int/cluster: {{ capi_cluster }}
    capi.skao.int/collections-branch: {{ capi_collections_branch }}
    capi.skao.int/component: worker
    capi.skao.int/worker-group: {{ group.name }}
spec:
  template:
    spec:
      verbosity: 5
      files:
      - path: /etc/kubernetes/clouds.yaml
        content: {{ capi_capo_openstack_cloud_yaml_b64 }}
        encoding: base64
        owner: root
        permissions: "0600"
      - path: /etc/certs/cacert
        content: {{ capi_capo_cacert_b64 }}
        encoding: base64
        owner: root
        permissions: "0600"
      - path: /etc/kubernetes/initialise-install-tools.sh
        content: |
          #!/usr/bin/bash
          echo ""
          echo "==================================================================="
          echo "preKubeadmCommands: initialise $(date)"
          set -x

          apt update
          apt install -y --allow-change-held-packages gettext-base git ca-certificates net-tools python3-pip
          pip3 install ansible kubernetes

          cd /usr/src && \
          git clone https://gitlab.com/ska-telescope/sdi/ska-ser-ansible-collections.git --recurse-submodules && \
          cd ska-ser-ansible-collections && \
          git checkout {{ capi_collections_branch }} && \
          git submodule update --init --recursive

          cat <<EOF > run-play.sh
          #!/usr/bin/bash
          echo "run-play.sh args are: \$*"
          cd /usr/src/ska-ser-ansible-collections
          export ANSIBLE_COLLECTIONS_PATHS="/usr/src/ska-ser-ansible-collections:$HOME/.ansible/collections:/usr/share/ansible/collections"
          export KUBECONFIG="/etc/kubernetes/admin.conf"
          export ANSIBLE_CONFIG="/usr/src/ska-ser-ansible-collections/datacentres/production/installation/ansible.cfg"
          ansible-playbook \
            --connection=local \
            --limit localhost \
            --become \
            --extra-vars "ansible_user=ubuntu" \
            --extra-vars "common_dns_servers=\"{{ capi_dns_servers | join(' ') }}\"" \
            --extra-vars "docker_allow_version_change=true" \
            --extra-vars "docker_mtu={{ capi_docker_mtu }}" \
            --extra-vars "docker_activate_nvidia={{ context.nvidia_enabled | default(false) | lower }}" \
            --extra-vars "containerd_activate_nvidia={{ context.nvidia_enabled | default(false) | lower }}" \
            --extra-vars "{{ capi_oci_mirror_type }}={{ capi_oci_mirror_ip }}" \
            --extra-vars "harbor_local_domain={{ capi_oci_mirror_local_domain }}" \
            --extra-vars "harbor_port={{ capi_oci_mirror_port }}" \
            --extra-vars "capi_cluster={{ capi_cluster }}" \
            --extra-vars "k8s_kubeconfig=/etc/kubernetes/admin.conf" \
            --extra-vars "k8s_kubernetes_version={{ capi_k8s_version }}" \
{% for key,value in (context.init_extra_vars | default({})).items()  %}
            --extra-vars "{{ key }}={{ value }}" \
{% endfor %}
            /usr/src/ska-ser-ansible-collections/ansible_collections/ska_collections/clusterapi/playbooks/\$1 \${@:2}
          EOF

          chmod a+x run-play.sh
          cat run-play.sh

          echo "Finished."
          exit 0
        owner: root:root
      - path: /etc/kubernetes/kubeadm-pre.sh
        content: |
          #!/usr/bin/bash
          echo ""
          echo "==================================================================="
          echo "preKubeadmCommands: deploy $(date)"
          set -x

          if [ "{{ context.nvidia_enabled | default(false) | lower }}" = "true" ]; then
            ansible-galaxy role install \
              -r /usr/src/ska-ser-ansible-collections/requirements.yml \
              --force \
              -p /usr/share/ansible/roles
            /usr/src/ska-ser-ansible-collections/run-play.sh nvidia.yml -vv \
              --extra-vars "nvidia_driver_branch={{ context.nvidia_driver_version | default(capi_nvidia_driver_version) }}" \
              --extra-vars "nvidia_driver_skip_reboot=true"
          fi

          /usr/src/ska-ser-ansible-collections/run-play.sh containerd.yml -vv
          /usr/src/ska-ser-ansible-collections/run-play.sh docker.yml -vv
          if [ "{{ context.oci_image_cleanup_enabled | default(true) | lower }}" = "true" ]; then
            /usr/src/ska-ser-ansible-collections/run-play.sh oci_image_cleanup_cron.yml -vv
          fi
          /usr/src/ska-ser-ansible-collections/run-play.sh ntp.yml -vv
          /usr/src/ska-ser-ansible-collections/run-play.sh dns.yml -vv
          /usr/src/ska-ser-ansible-collections/run-play.sh node-exporter.yml -vv

          if [ "{{ capi_capo_run_kubelet_install | lower }}" = "true" ]; then
            /usr/src/ska-ser-ansible-collections/run-play.sh k8s-setup.yml -vv
          fi

          /usr/src/ska-ser-ansible-collections/run-play.sh install-tools.yml --tags helm -vv

          echo "preKubeadmCommands: end $(date)"
          exit 0
        owner: root:root
      - path: /etc/kubernetes/kubeadm-post.sh
        content: |
          #!/usr/bin/bash
          echo ""
          echo "==================================================================="
          echo "worker postKubeadmCommands: start $(date)"
          set -x

          export KUBECONFIG=/etc/kubernetes/kubelet.conf
          if [ -f "/etc/kubernetes/super-admin.conf" ]; then
            export KUBECONFIG=/etc/kubernetes/super-admin.conf
          fi

          if [ -f "/etc/kubernetes/admin.conf" ]; then
            echo "/etc/kubernetes/admin.conf already exists"
            exit 0
          fi

          kubectl config view --flatten > /etc/kubernetes/admin.conf

          echo "Finished."
          exit 0
        owner: root:root
      joinConfiguration:
        nodeRegistration:
          name: '{{ '{{ local_hostname }}' }}'
          ignorePreflightErrors: {{ capi_ignore_preflight_errors | to_json }}
          kubeletExtraArgs: {{
            capi_worker_kubelet_args |
            combine({"node-labels": ((group.labels | default(capi_worker_labels)) | join(',')) }) |
            combine(group.kubelet_extra_args | default({}), recursive=true) |
            to_kubelet_args
          }}
          taints: {{ (group.taints | default(capi_worker_taints)) | to_json }}
      postKubeadmCommands:
      - 'echo "worker postKubeadmCommands: start $(date)" >>/tmp/capo-config.log'
      - /usr/bin/bash /etc/kubernetes/kubeadm-post.sh >>/tmp/capo-config.log
        2>&1
      preKubeadmCommands:
      - 'echo "worker preKubeadmCommands: start $(date)" >>/tmp/capo-config.log'
      - /usr/bin/bash /etc/kubernetes/initialise-install-tools.sh >>/tmp/capo-config.log
        2>&1
      - /usr/bin/bash /etc/kubernetes/kubeadm-pre.sh >>/tmp/capo-config.log
        2>&1
---
apiVersion: cluster.x-k8s.io/v1beta1
kind: MachineDeployment
metadata:
  name: {{ capi_cluster }}-{{ group.name }}
  namespace: {{ capi_kube_namespace }}
  labels:
    capi.skao.int/cluster: {{ capi_cluster }}
    capi.skao.int/collections-branch: {{ capi_collections_branch }}
    capi.skao.int/component: worker
    capi.skao.int/worker-group: {{ group.name }}
spec:
  clusterName: {{ capi_cluster }}
  replicas: {{ group.count | default(capi_worker_count) }}
  progressDeadlineSeconds: {{ capi_capo_openstack_instance_create_timeout }}
  template:
    spec:
      version: v{{ capi_k8s_version }}
      clusterName: {{ capi_cluster }}
      failureDomain: {{ capi_capo_openstack_failure_domain }}
      bootstrap:
        configRef:
          apiVersion: bootstrap.cluster.x-k8s.io/v1beta1
          kind: KubeadmConfigTemplate
          name: {{ capi_cluster }}-{{ group.name }} # SPEC HASH SUFFIX ADDED DURING RENDERING
      infrastructureRef:
        apiVersion: infrastructure.cluster.x-k8s.io/v1beta1
        kind: OpenStackMachineTemplate
        name: {{ capi_cluster }}-{{ group.name }} # SPEC HASH SUFFIX ADDED DURING RENDERING
---